#############################################################################
##
#W  PackageInfo.g       GAP 4 Package `FinLie'                   Bettina Eick
##															     Tobias Moede
##

SetPackageInfo( rec(

PackageName := "FinLie",
Subtitle    := "Computation with finite Lie algebras",
Version     := "1.1",
Date        := "01/03/2018",

##  <#GAPDoc Label="PKGVERSIONDATA">
##  <!ENTITY VERSION "1.1">
##  <!ENTITY RELEASEDATE "01 March 2018">
##  <#/GAPDoc>

ArchiveFormats := ".tar",
ArchiveURL     := 
  "http://cayley.math.nat.tu-bs.de/software/eick/finlie/finlie-1.0",

Persons          := [ 
  rec( LastName      := "Eick",
       FirstNames    := "Bettina",
       IsAuthor      := true,
       IsMaintainer  := true,
       Email         := "b.eick@tu-bs.de",
       WWWHome       := "http://www.icm.tu-bs.de/~beick",
       PostalAddress := Concatenation([
               "Institut Computational Mathematics",
               "TU Braunschweig\n",
               "Universitaetsplatz 2 \n D-38106 Braunschweig \n Germany"] ),
       Place         := "Braunschweig",
       Institution   := "TU Braunschweig"),

 rec( LastName       := "Moede",
       FirstNames    := "Tobias",
       IsAuthor      := true,
       IsMaintainer  := true,
       Email         := "t.moede@tu-bs.de",
       WWWHome       := "http://www.icm.tu-bs.de/~tobmoede",
       PostalAddress := Concatenation([
               "Institut Computational Mathematics",
               "TU Braunschweig\n",
               "Universitaetsplatz 2 \n D-38106 Braunschweig \n Germany"] ),
       Place         := "Braunschweig",
       Institution   := "TU Braunschweig") ],

Status              := "dev",

README_URL 
  := "http://cayley.math.nat.tu-bs.de/software/eick/finlie/README",
PackageInfoURL 
  := "http://cayley.math.nat.tu-bs.de/software/eick/finlie/PackageInfo.g",

AbstractHTML     :=
"This package provides algorithms for computations with finite Lie algebras",

PackageWWWHome 
  := "http://cayley.math.nat.tu-bs.de/software/eick/finlie",

PackageDoc     := rec(
                BookName  := "finlie",
                ArchiveURLSubset   := [ "doc", "htm" ],
                HTMLStart := "htm/chapters.htm",
                PDFFile   := "doc/manual.pdf",
                SixFile   := "doc/manual.six",
                LongTitle := "Computation with finite Lie algebras",
                Autoload  := true),

Dependencies    := rec(
                GAP                    := ">= 4.3fix4",
                NeededOtherPackages    := [],
                SuggestedOtherPackages := [],
                ExternalConditions     := []),

AvailabilityTest := ReturnTrue,
BannerString     := "Loading FinLie 1.1  ...\n",
Autoload         := false,
Keywords         := [] ));

