
CentralizerByBlocks := function(mat, bl)
    local r, c, d, e, i, f, M, C, s, j, m;

    r := Length(Set(bl));
    c := List([1..r], x -> []);
    s := List([1..r], x -> 1);

    # the first block is special
    d := Length(Filtered(bl, x -> x = 1));
    if d > 1 then 
        C := GL(d,2);
        s[1] := Size(C);
        c[1] := ShallowCopy(GeneratorsOfGroup(C));
        for j in [1..Length(c[1])] do
            m := MutableIdentityMat(Length(mat),GF(2));
            m{[1..d]}{[1..d]} := c[1][j];
            c[1][j] := m;
        od;
    fi;
 
    e := d+1;
    for i in [2..r] do
        d := Length(Filtered(bl, x -> x = i));
        f := d+e-1;
        if d > 1 then 
            M := mat{[e..f]}{[e..f]};
            C := Centralizer(GL(d,2),M);
            c[i] := ShallowCopy(GeneratorsOfGroup(C));
            for j in [1..Length(c[i])] do
                m := MutableIdentityMat(Length(mat),GF(2));
                m{[e..f]}{[e..f]} := c[i][j];
                c[i][j] := m;
            od;
            s[i] := Size(C);
        fi;
        e := f+1;
    od;

    C := Group(Concatenation(c));
    SetSize(C, Product(s));
    return C;
end;

MyWedge := function(mat)
    local n, d, new, r, c, i, j, l, k;
    n := Length(mat);
    d := n*(n-1)/2;
    new := NullMat(d,d,GF(2));
    r := 0;
    c := 0;
    for i in [1..n-1] do
        for j in [i+1..n] do
            r := r+1; 
            c := 0;
            for l in [1..n-1] do
                for k in [l+1..n] do
                    c := c+1;
                    new[r][c] := mat[i][k]*mat[j][l]+mat[j][k]*mat[i][l];
                od;
            od;
        od;
    od;
    return new;
end;

ActionOnTables := function(mat)
    local n, d, trs, wrs, out, inn;

    n := Length(mat);
    d := n*(n-1)/2;

    # the outer part
    trs := MyWedge(mat^-1);
    out := KroneckerProduct(trs, IdentityMat(n,GF(2)));

    # the inner part 
    inn := KroneckerProduct(IdentityMat(d,GF(2)),mat);

    return inn*out;
end;

CentralizerOnTables := function( mat, bl )
    local C,c,B;
    C := CentralizerByBlocks(mat,bl);
    c := List(GeneratorsOfGroup(C), ActionOnTables);
    B := Group(c);
    SetSize(B,Size(C));
    return B;
end;

GLOnTables := function(n)
    local C, c, B;
    C := GL(n,2);
    c := List(GeneratorsOfGroup(C), ActionOnTables);
    B := Group(c);
    SetSize(B,Size(C));
    return B;
end;

